---
stages:
  - pre-commit
  - test-localstack
  - test-real
  - pkg
  - pop-release

include:
  - project: saltstack/pop/cicd/ci-templates
    file: /lint/pre-commit-run-all.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /release/pop_release.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /pkg/pkg_centos7_onedir.yml

pre-commit-run-all:
  image: registry.gitlab.com/saltstack/pop/cicd/containers/alpinelint:py39

variables:
  CICD_UPSTREAM_PATH: "vmware/idem/idem-aws"

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID == null

.test-suite:
  services:
    - name: localstack/localstack:1.0.4
      alias: localstack
  variables:
    ACCT_KEY: 'nw4ZjRfNRCFWQS0C6Nau_0YvGFBownpdxDLoS3qjZq0='
    ACCT_FILE: .gitlab-ci-creds.yml.fernet
    HOSTNAME_EXTERNAL: localstack
    USE_SSL: "false"
    EDGE_PORT: 4566
    FORCE_NONINTERACTIVE: 1
  stage: test-localstack
  needs:
    - pre-commit-run-all
  script:
    - python3 -m pip install nox acct
    - acct encrypt .gitlab-ci-creds.yml --acct-key="$ACCT_KEY"
    - nox -e tests-3 -- -vv tests/integration/idem_aws/  tests/unit/idem_aws/
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days

# Run this on real aws
# In gitlab go to your fork of idem-aws -> Settings -> CI / CD -> Variables
# Create a File key called "CI_ACCT_FILE" that contains the contents of your encrypted fernet file
# Create a Variable key called "CI_ACCT_KEY" that contains the key for decrypting your acct file
# TODO do some before and after things, like before the entire test starts list EVERYTHING
#     When the test is over list EVERYTHING again.
#     If there were any changes to real AWS after the tests (because tests didn't clean up properly or removed stuff)
#     then explode and throw a ton of descriptive errors
.test-suite-real:
  stage: test-real
  needs:
    - pre-commit-run-all
    - tests-3.7
    - tests-3.8
    - tests-3.9
    - tests-3.10
    - tests-pro
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days
  image: python:3.7
  variables:
    TEST_ON_REAL_AWS: "true"
  when: manual

tests-3.7:
  extends: .test-suite
  image: python:3.7

tests-3.8:
  extends: .test-suite
  image: python:3.8

tests-3.9:
  extends: .test-suite
  image: python:3.9

tests-3.10:
  extends: .test-suite
  image: python:3.10

# In gitlab go to your fork of idem-aws -> Settings -> CI / CD -> Variables
# Create a Variable key called "CI_LOCALSTACK_API_KEY" that contains your personal localstack pro api key
# The tests that use localstack pro features will now be enabled on your personal branch
tests-pro:
  extends: .test-suite
  image: docker
  services:
    - name: docker:dind
      alias: localstack
  before_script:
    - apk add python3-dev py3-pip gcc libc-dev libffi-dev musl-dev openssl-dev
              cargo libxml2-dev libxslt-dev jpeg-dev zlib-dev
    - docker pull ubuntu:focal
    - docker tag ubuntu:focal localstack-ec2/idem-test-ami:ami-007734
    - docker run
        -v /var/run/docker.sock:/var/run/docker.sock
        -e LOCALSTACK_API_KEY=$CI_LOCALSTACK_API_KEY
        -p 4566:4566 -p 4510-4559:4510-4559
        --rm --interactive --detach
        localstack/localstack:0.14.3
  variables:
    REQUIRE_PRO: 1
  rules:
    - if: "$CI_LOCALSTACK_API_KEY != null"

tests-apigatewayv2:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/apigatewayv2/ tests/integration/idem_aws/exec/apigatewayv2/

tests-ec2:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/ec2/ tests/integration/idem_aws/exec/ec2/

tests-ecr:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/ecr/

tests-eks-cluster:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/eks/test_cluster.py

tests-eks-node-group:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/eks/test_addon.py tests/integration/idem_aws/states/eks/test_nodegroup.py

tests-eks-fargate-profile:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/eks/test_fargate_profile.py

tests-iam:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/iam/ tests/integration/idem_aws/exec/iam/

tests-config:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/config/

tests-cloud-watch:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/cloudwatch/

tests-cloudwatch-logs:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/cloudwatchlogs/

tests-elasticache:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/elasticache/

tests-elbv2:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/elbv2/ tests/integration/idem_aws/exec/elbv2/

tests-elb:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/elb/

tests-rds:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/rds/

tests-logs:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/logs/

tests-guardduty:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/guardduty

tests-organizations:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/organizations/test_organization.py tests/integration/idem_aws/states/organizations/test_organization_policy.py tests/integration/idem_aws/states/organizations/test_organization_policy_attachment.py tests/integration/idem_aws/states/organizations/test_organization_unit.py

tests-cloud-trail:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/cloudtrail/

tests-docdb:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/docdb/

tests-dynamodb:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/exec/dynamodb tests/integration/idem_aws/states/dynamodb

tests-kms:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - export CI_ACCT_NUM="$CI_ACCT_NUM"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/kms

tests-sns:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/sns/

tests-lambda:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/lambda

tests-route53:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/route53/

tests-autoscaling:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/autoscaling/

tests-efs:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/efs/

tests-s3:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/s3

tests-cloudwatch-events:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/events

tests-costexplorer:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/costexplorer/ tests/integration/idem_aws/exec/costexplorer/

tests-wafv2:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/wafv2/

tests-neptune:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/neptune/

tests-apigateway:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/apigateway/

tests-acm:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/acm/

tests-general-resource:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/test_caller_identity.py

tests-budgets:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/budgets/

tests-application-autoscaling:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/application_autoscaling/

tests-cloudfront:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/cloudfront/

tests-sqs:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/sqs/

build-docs:
  stage: pkg
  image: python:3.10
  script:
    - pip install -U pip setuptools wheel nox
    - nox -e 'docs-html(clean=True)'
    - mv docs/_build/html html
  artifacts:
    paths:
      - html
    expire_in: 7 days

pages:
  stage: pop-release
  image: alpine:3.16
  dependencies:
    - build-docs
  script:
    - mkdir -p public/en
    - mv html public/en/latest
    - cp docs/redirector.html public/index.html
    - cp docs/redirector.html public/en/index.html
    - sed -i 's:./latest/index.html:./en/latest/index.html:' public/index.html
    - 'echo "Gitlab Pages available at: ${CI_PAGES_URL}"'
  artifacts:
    paths:
      - public
    expire_in: 7 days

publish-docs:
  stage: pop-release
  variables:
    CICD_S3_UPLOAD_DOCS: "true"
    CICD_S3_SOURCE_PATH: "public/"
    CICD_S3_DEST_PATH: "docs.idemproject.io/idem-aws/"
    CICD_SOURCE_PROJECT_NAME: $CI_PROJECT_NAME
    CICD_SOURCE_COMMIT: $CI_COMMIT_SHORT_SHA
    CICD_SOURCE_GITLAB_PROJECT_PATH: $CI_PROJECT_PATH
    CICD_SOURCE_COMMIT_REF_NAME: $CI_COMMIT_REF_NAME
    CICD_SOURCE_GITLAB_PIPELINE_URL: $CI_PIPELINE_URL
    CICD_SOURCE_GITLAB_PIPELINE_ID: $CI_PIPELINE_ID
    CICD_SOURCE_GITLAB_JOB_NAME: pages
  rules:
    - if: '$CI_COMMIT_REF_PROTECTED == "true" && $CI_COMMIT_TAG != null && $CI_PROJECT_PATH == $CICD_UPSTREAM_PATH'
      when: on_success
    - when: never
  trigger:
    project: vmware/idem/cicd/artifact-upload
    strategy: depend

upload-rpm:
  stage: pop-release
  variables:
    CICD_ARTIFACTORY_UPLOAD: "true"
    CICD_SOURCE_PROJECT_NAME: $CI_PROJECT_NAME
    CICD_SOURCE_COMMIT: $CI_COMMIT_SHORT_SHA
    CICD_SOURCE_GITLAB_PROJECT_PATH: $CI_PROJECT_PATH
    CICD_SOURCE_COMMIT_REF_NAME: $CI_COMMIT_REF_NAME
    CICD_SOURCE_GITLAB_PIPELINE_URL: $CI_PIPELINE_URL
    CICD_SOURCE_GITLAB_PIPELINE_ID: $CI_PIPELINE_ID
    CICD_SOURCE_GITLAB_JOB_NAME: pkg-centos7-onedir
    CICD_JFROG_BLOB_REPO_PATH: "${CI_COMMIT_REF_NAME}/linux/rpm/"
    CICD_JFROG_BLOB_REPO: "idem-release-generic-local"
    CICD_JFROG_BLOB_PATTERN: "idem*"
    CICD_JFROG_BLOB_SOURCE_PATH: "artifacts/"
  rules:
    - if: '$CI_COMMIT_REF_PROTECTED == "true" && $CI_COMMIT_TAG == null && $CI_PROJECT_PATH == $CICD_UPSTREAM_PATH'
      when: on_success
    - when: never
  trigger:
    project: vmware/idem/cicd/artifact-upload
    strategy: depend

release-rpm:
  stage: pop-release
  variables:
    CICD_ARTIFACTORY_UPLOAD: "true"
    CICD_SOURCE_PROJECT_NAME: $CI_PROJECT_NAME
    CICD_SOURCE_COMMIT: $CI_COMMIT_SHORT_SHA
    CICD_SOURCE_GITLAB_PROJECT_PATH: $CI_PROJECT_PATH
    CICD_SOURCE_COMMIT_REF_NAME: $CI_COMMIT_REF_NAME
    CICD_SOURCE_GITLAB_PIPELINE_URL: $CI_PIPELINE_URL
    CICD_SOURCE_GITLAB_PIPELINE_ID: $CI_PIPELINE_ID
    CICD_SOURCE_GITLAB_JOB_NAME: pkg-tags-centos7-onedir
    CICD_JFROG_BLOB_REPO_PATH: "${CI_COMMIT_REF_NAME}/linux/rpm/"
    CICD_POP_RELEASE: "false"
    CICD_JFROG_BLOB_REPO: "idem-release-generic-local"
    CICD_JFROG_BLOB_PATTERN: "*.rpm"
    CICD_JFROG_BLOB_SOURCE_PATH: "artifacts/"
  rules:
    - if: '$CI_COMMIT_REF_PROTECTED == "true" && $CI_COMMIT_TAG != null && $CI_PROJECT_PATH == $CICD_UPSTREAM_PATH'
      when: on_success
    - when: never
  trigger:
    project: vmware/idem/cicd/artifact-upload
    strategy: depend
